//----------------------------------------------------------------------------

//General control module, header file

//----------------------------------------------------------------------------

#ifndef CONTROL_HPP
#define CONTROL_HPP

//----------------------------------------------------------------------------

#include "systimer.hpp"
#include "display.hpp"
#include "keyboard.hpp"
#include "encoder.hpp"
#include "menu.hpp"

//----------------------------------------------------------------------------
//---------------------------- TControl class: -------------------------------
//----------------------------------------------------------------------------

class TControl
{
private:
  Pin_VCC_t Pin_VCC;
  TKeyboard *Keyboard;
  TMenuItems *Menu;
  TSoftTimer *MenuTimer;
  TSoftTimer *ExitTimer;
  bool MenuBrief;
  static const uint16_t MENU_BRIEF = 1000;
  static const uint16_t MENU_EXIT = 5000;
  uint8_t MnuIndex;
  uint8_t BackMenu;
  void HardwareInit(void);
  void WatchdogService(void);
  void DataSaveService(void);
  Pin_PB4_t Pin_PB4;
  Pin_PC5_t Pin_PC5;
  //Pin_RXD_t Pin_RXD;
  //Pin_TXD_t Pin_TXD;
  //Pin_DIR_t Pin_DIR;
  Pin_PD5_t Pin_PD5;
  Pin_PD6_t Pin_PD6;
public:
  TControl(void);
  void Execute(void);
};

//----------------------------------------------------------------------------

#endif
