//----------------------------------------------------------------------------

//EEPROM support module, header file

//----------------------------------------------------------------------------

#ifndef EEPROM_HPP
#define EEPROM_HPP

//------------------------------- Constants: ---------------------------------

enum EE_Map_t
{
  EE_SIGN,
  EE_MODE,
  EE_TIME, EE_TIME1, EE_TIME2, EE_TIME3,
  EE_LAPTIME, EE_LAPTIME1, EE_LAPTIME2, EE_LAPTIME3,
  EE_DIAMETER, EE_DIAMETER1, EE_DIAMETER2, EE_DIAMETER3,
  EE_OP_MENUS,
  EE_OP_RTCRES,
  EE_OP_LENRES,
  EE_OP_SPDRES,
  EE_OP_FONT,
  EE_OP_SPSEL,
  EE_OP_LOOP,
  EE_OP_ENC,
  EE_PARAMS
};

//----------------------------------------------------------------------------
//----------------------------- TEeprom class: -------------------------------
//----------------------------------------------------------------------------

class TEeprom
{
private:
  bool fValid;
  static uint8_t const EE_SIGNATURE = 0xEA;
protected:
public:
  TEeprom(void);
  uint8_t Rd8(uint8_t addr, uint8_t def = 0);    //read 8 bit
  uint8_t Rd8Chk(uint8_t addr, uint8_t max, uint8_t def = 0); //read and check
  void Wr8(uint8_t addr, uint8_t val);           //write 8 bit
  uint32_t Rd32(uint8_t addr, uint32_t def = 0); //read 32 bit
  void Wr32(uint8_t addr, uint32_t val);         //write 32 bit
  void Validate(void);                           //write signature
  void Invalidate(void);                         //reset the validity flag
};

//----------------------------------------------------------------------------

extern TEeprom *Eeprom;

//----------------------------------------------------------------------------

#endif
