//----------------------------------------------------------------------------

//Keyboard support module: header file

//----------------------------------------------------------------------------

#ifndef KEYBOARD_HPP
#define KEYBOARD_HPP

//----------------------------------------------------------------------------

#include "systimer.hpp"

//------------------------------- Constants: ---------------------------------

enum KeyMsg_t //button message codes
{
  KEY_NO,   //no pressing
  KEY_PRS,  //button press
  KEY_REL,  //button release
  KEY_HOLD, //button hold
  KEY_LONG, //long button hold
  KEY_UP,   //step up
  KEY_DN    //step down
};

//----------------------------------------------------------------------------
//--------------------------- TKeyboard class: -------------------------------
//----------------------------------------------------------------------------

class TKeyboard
{
private:
  static uint16_t const DEBOUNCE_TM  = 50; //debounce interval, ms
  static uint16_t const HOLD_DELAY = 1000; //button hold delay, ms
  static uint16_t const LONG_DELAY = 3000; //long hold delay, ms
  Pin_KEY_t Pin_KEY;
  TSoftTimer *KeyTimer;
  bool Prev_Key;
  KeyMsg_t LastMsg;
public:
  TKeyboard(void);
  void Execute(void);
  KeyMsg_t Message;
  bool Key(void);
};

//----------------------------------------------------------------------------

#endif
