//----------------------------------------------------------------------------

//Project:  E-004 counter
//Compiler: IAR EWAVR 6.12
//Target:   ATmega88PA
//Fuses:    F9 D5FF
//E-mail:   wubblick@yahoo.com

//------------------------ Program Description: ------------------------------

//The digital tape counter is designed for installation in reel-to-reel tape
//recorders. Many tape recorders have mechanical counters that are best replaced
//with electronic ones. The counter has the following features: indication of
//real time, tape metrage, tape speed. The counter is assembled on a single
//printed circuit board, the shape of which is selected for Elektronika-003,
//Elektronika-004, Olymp-003 tape recorders. The transport of the tape recorder
//must have a rotating roller that is constantly in contact with the tape.
//The roller diameter can be from 30 to 60 mm, but you can add another range of
//diameters to the source code of the program. Reflective optocouplers are used
//as roller rotation sensors. An chopper is installed on the roller, which
//should have 5 blades. Another number of blades is possible, but this number
//must be entered in the source code of the program. Automatic calibration of
//the diameter of the bypass roller is provided. The counting result is
//displayed on a 6 or 7 digit LED display. To minimize the noise level, a static
//indication is used, the indicators are connected to the outputs of the 74HC595
//shift registers.

//----------------------------------------------------------------------------

#include "main.hpp"
#include "control.hpp"

//------------------------------ Variables: ----------------------------------

TControl *Control;

//----------------------------------------------------------------------------
//---------------------------- Main Program: ---------------------------------
//----------------------------------------------------------------------------

int main(void)
{
  TSysTimer::Init();        //system timer init
  Control = new TControl(); //creating Control object

  do                        //main loop
  {
    TSysTimer::Sync();      //system ticks and main loop sync
    Control->Execute();     //execution of the control task
  }
  while(1);
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
